package com.zhongzheng.modules.activity.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.github.pagehelper.Page;
import com.zhongzheng.common.utils.DateUtils;
import com.zhongzheng.modules.activity.bo.ActivityAdvertisingAddBo;
import com.zhongzheng.modules.activity.bo.ActivityAdvertisingEditBo;
import com.zhongzheng.modules.activity.bo.ActivityAdvertisingQueryBo;
import com.zhongzheng.modules.activity.domain.ActivityAdvertising;
import com.zhongzheng.modules.activity.mapper.ActivityAdvertisingMapper;
import com.zhongzheng.modules.activity.service.IActivityAdvertisingService;
import com.zhongzheng.modules.activity.vo.ActivityAdvertisingVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 广告发布储存Service业务层处理
 *
 * @author change
 * @date 2021-05-17
 */
@Service
public class ActivityAdvertisingServiceImpl extends ServiceImpl<ActivityAdvertisingMapper, ActivityAdvertising> implements IActivityAdvertisingService {

    @Autowired
    private IActivityAdvertisingService activityAdvertisingService;

    @Override
    public ActivityAdvertisingVo queryById(Long id){
        ActivityAdvertising db = this.baseMapper.selectById(id);
        return BeanUtil.toBean(db, ActivityAdvertisingVo.class);
    }

    @Override
    public List<ActivityAdvertisingVo> queryList(ActivityAdvertisingQueryBo bo) {
        LambdaQueryWrapper<ActivityAdvertising> lqw = Wrappers.lambdaQuery();
        lqw.ne(bo.getStatus() == null,ActivityAdvertising::getStatus,0);
        lqw.eq(StrUtil.isNotBlank(bo.getAdverUrl()), ActivityAdvertising::getAdverUrl, bo.getAdverUrl());
        lqw.eq(StrUtil.isNotBlank(bo.getJumpUrl()), ActivityAdvertising::getJumpUrl, bo.getJumpUrl());
        lqw.eq(StrUtil.isNotBlank(bo.getRemarks()), ActivityAdvertising::getRemarks, bo.getRemarks());
        lqw.eq(bo.getReStatus() != null, ActivityAdvertising::getReStatus, bo.getReStatus());
        lqw.eq(bo.getStatus() != null, ActivityAdvertising::getStatus, bo.getStatus());
        lqw.like(StrUtil.isNotBlank(bo.getAdvName()), ActivityAdvertising::getAdvName, bo.getAdvName());
        lqw.apply(bo.getStartCreateTime() != null,"create_time BETWEEN {0} and {1}",bo.getStartCreateTime(),bo.getEndCreateTime());
        lqw.apply(bo.getEndTime() != null,"end_time BETWEEN {0} and {1}",bo.getStartTime(),bo.getEndTime());
        lqw.apply(bo.getStarIssueTime() != null,"start_time BETWEEN {0} and {1}",bo.getStarIssueTime(),bo.getEndIssueTime());
        lqw.orderByDesc(ActivityAdvertising::getUpdateTime);
        List<ActivityAdvertising> list = this.list(lqw);
        return entity2Vo(list);
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<ActivityAdvertisingVo> entity2Vo(Collection<ActivityAdvertising> collection) {
        List<ActivityAdvertisingVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, ActivityAdvertisingVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<ActivityAdvertising> page = (Page<ActivityAdvertising>)collection;
            Page<ActivityAdvertisingVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public long insertByAddBo(ActivityAdvertisingAddBo bo) {
        ActivityAdvertising add = BeanUtil.toBean(bo, ActivityAdvertising.class);
        validEntityBeforeSave(add);
        add.setStatus(1);
        add.setCreateTime(DateUtils.getNowTime());
        add.setUpdateTime(DateUtils.getNowTime());
        return activityAdvertisingService.save(add)?add.getId():0;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ActivityAdvertisingVo updateByEditBo(ActivityAdvertisingEditBo bo) {
        ActivityAdvertising update = BeanUtil.toBean(bo, ActivityAdvertising.class);
        ActivityAdvertisingVo activityAdvertisingVo = this.queryById(update.getId());
        validEntityBeforeSave(update);
        update.setUpdateTime(DateUtils.getNowTime());
        activityAdvertisingService.updateById(update);
        return activityAdvertisingVo;
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(ActivityAdvertising entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        ArrayList<ActivityAdvertising> activityAdvertisingList = new ArrayList<>();
        ids.stream().forEach(id -> activityAdvertisingList.add(new ActivityAdvertising().setId(id).setStatus(0).setUpdateTime(DateUtils.getNowTime())));
        return activityAdvertisingService.updateBatchById(activityAdvertisingList);
    }

    @Override
    public List<ActivityAdvertisingVo> queryIssueList(ActivityAdvertisingQueryBo bo) {
        bo.setStartTime(DateUtils.getNowTime());
        List<ActivityAdvertisingVo> activityAdvertisingVos = baseMapper.queryIssueList(bo);
        return activityAdvertisingVos;
    }

}
